package org.gvsig.remoteClient.gml;
/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2004 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 *
 * For more information, contact:
 *
 *  Generalitat Valenciana
 *   Conselleria d'Infraestructures i Transport
 *   Av. Blasco Ibez, 50
 *   46010 VALENCIA
 *   SPAIN
 *
 *      +34 963862235
 *   gvsig@gva.es
 *      www.gvsig.gva.es
 *
 *    or
 *
 *   IVER T.I. S.A
 *   Salamanca 50
 *   46005 Valencia
 *   Spain
 *
 *   +34 963163400
 *   dac@iver.es
 */
/* CVS MESSAGES:
 *
 * $Id: GMLException.java,v 1.1 2006/08/10 12:00:49 jorpiell Exp $
 * $Log: GMLException.java,v $
 * Revision 1.1  2006/08/10 12:00:49  jorpiell
 * Primer commit del driver de Gml
 *
 *
 */
/**
 * GML Exception.
 * @author Jorge Piera Llodr (piera_jor@gva.es)
 */
public class GMLException extends Exception {
	public static final int EXC_NO_SCHEMA = 0;
	public static final int EXC_ATTRIB_WITH_INVALID_FORMAT = 1;
	public static final int EXC_PARSE = 2;
	public static final int EXC_READ_FILE = 3;
	public static final int EXC_NO_GEOMETRY = 4;
	
	
	private int exceptionType;
	
	public GMLException(int exceptionType) {
		super();
		this.exceptionType = exceptionType;
	}

	/**
	 * @return Returns the exceptionType.
	 */
	public int getExceptionType() {
		return exceptionType;
	}

	
	

}
