package com.hardcode.driverManager;

/**
 * Interfaz a implementar por los objetos de validacin
 *
 * @author Fernando Gonzlez Corts
 */
public interface DriverValidation {
    /**
     * El mtodo validate se invocar al crear los drivers, y ser el validador
     * el que indicar qu driver es vlido para la aplicacin y cual no
     *
     * @param d Driver a validar
     *
     * @return true o false en caso de que el driver sea o no sea valido
     */
    public boolean validate(Driver d);
}
